/*******************************************************************************

  Copyright (C) 2010, 2013 LIFIA - Facultad de Informatica - Univ. Nacional de La Plata

********************************************************************************

  This file is part of DTV-mpegparser implementation.

    DTV-mpegparser is free software: you can redistribute it and/or modify it
  under the terms of the GNU Lesser General Public License as published by the Free
  Software Foundation, either version 2 of the License.

    DTV-mpegparser is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
  A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License along with
  this program. If not, see <http://www.gnu.org/licenses/>.

********************************************************************************

  Este archivo es parte de la implementación de DTV-mpegparser.

    DTV-mpegparser es Software Libre: Ud. puede redistribuirlo y/o modificarlo
  bajo los términos de la Licencia Pública General Reducida GNU como es publicada por la
  Free Software Foundation, según la versión 2 de la licencia.

    DTV-mpegparser se distribuye esperando que resulte de utilidad, pero SIN NINGUNA
  GARANTÍA; ni siquiera la garantía implícita de COMERCIALIZACIÓN o ADECUACIÓN
  PARA ALGÚN PROPÓSITO PARTICULAR. Para más detalles, revise la Licencia Pública
  General Reducida GNU.

    Ud. debería haber recibido una copia de la Licencia Pública General Reducida GNU
  junto a este programa. Si no, puede verla en <http://www.gnu.org/licenses/>.

*******************************************************************************/

#pragma once

#include "frontend.h"
#include <vector>

namespace tuner {

class ISDBTFrontend : public Frontend {
public:
	ISDBTFrontend();
	virtual ~ISDBTFrontend();

	//	Network
	virtual size_t getCount() const;
	virtual std::string getName( size_t nIndex ) const;
	virtual size_t find( const std::string &name ) const;

	virtual bool start( size_t nIndex );

protected:
	//	Type
	typedef struct {
		int id;
		int freq;
	} Channel;

	virtual bool setFrequency( int freq, int khBandwidth )=0;

	//	Aux frequencies
	size_t first( size_t nIndex ) const;
	void addChannel( int firstFreq, int firstChannel, int lastChannel );
	void buildChannels();

private:
	int _bandwidth;
	int _firstChannel;
	int _maxChannels;
	int _chan;
	std::vector<Channel> _channels;
};

}

