#pragma once

#include "output.h"
#include <util/types.h>

namespace util {
namespace net {
	class Socket;
	class SockAddr;
}
}

namespace tuner {
namespace player {
namespace ts {

class RTPOutput : public Output {
public:
	RTPOutput();
	virtual ~RTPOutput();

	virtual bool initialize();
	virtual void finalize();

	virtual const std::string &url() const;
	virtual bool write( util::Buffer *buf );

private:
	util::net::Socket *_socket;
	util::net::SockAddr *_sAddr;
	double _timestamp;
	int _pktsByOutput;
	int _pkts;
	int _seq;
	int _bIndex;
	util::BYTE *_buf;
	std::string _url;
};

}
}
}
	
